#ifndef __RULES_H__
#define __RULES_H__

#include "snort.h"
#include <string.h>


#define RULE_LOG   0
#define RULE_PASS  1
#define RULE_ALERT 2

#define ANY_SRC_IP     0x01
#define ANY_DST_IP     0x02
#define ANY_SRC_PORT   0x04
#define ANY_DST_PORT   0x08

typedef struct _Rule
{
   int type;
   u_long sip;
   u_long smask;
   u_long dip;
   u_long dmask;
   u_short sp;
   u_short dp;
   int proto;
   u_char flags;
   char *message;
   struct _Rule *next;
} Rule;
   
typedef Rule *RuleList;
typedef Rule *RulePtr;

typedef struct _ProgRules
{
   RulePtr PassRules;
   RulePtr LogRules;
   RulePtr AlertRules;
} ProgRules;


void ParseRulesFile(char *);
void ParseRule(char *);
void CreateRuleNode();
int RuleType(char *);
int WhichProto(char *);
int  ParseIP(char *, u_long *, u_long *);
int ParsePort(char *, u_short *);
void CheckRules();
void LogPkt();
void AlertPkt();
void DumpRuleList();

#endif /* __RULES_H__ */
